SystemOrganization addCategory: #'Pier-Setup'!

Object subclass: #PRDistribution
	instanceVariableNames: 'blog contentsWidget environmentPage metaEnvironmentPage breadcrumbWidget commandsPage googleAnalyticsWidget siteTitlePage sitemapPage stylesheetFile systemManagementPage viewsPage menuWidget loginCommandWidget mainEnvironmentPage childrenWidget postTickerWidget rootPage kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Setup'!

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:44'!
blog
	^ blog ifNil: [blog := PBBlog named: 'blog'].
! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:24'!
breadcrumbWidget
	^ breadcrumbWidget ifNil: [breadcrumbWidget := (PRComponent named: 'breadcrumb')
		componentClass: PRBreadcrumbWidget;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:25'!
childrenWidget
	^ childrenWidget ifNil: [childrenWidget := (PRComponent named: 'children')
		componentClass: PRChildrenWidget;
		write: 2
			using: PRChildrenWidget descriptionLevel;
		write: true
			using: PRChildrenWidget descriptionExpand;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:25'!
commandsPage
	^ commandsPage ifNil: [
		commandsPage := (PRPage named: 'commands') 
			addChild: ((PRComponent named: 'widget') componentClass: PRCommandsWidget; yourself);
			contents:
'Commands: +widget+'
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:26'!
contentsWidget
	^ contentsWidget ifNil: [
		contentsWidget := (PRComponent named: 'contents')
		componentClass: PRContentsWidget;
		write: '%c' using: PRContentsWidget descriptionHeading;
		yourself
	].! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:27'!
environmentPage
	^ environmentPage ifNil: [environmentPage := (PRPage named: 'environment')
		title: '_Environment';
		contents: 
'<div class="container">
	<div class="header column span-24 last">
		<div class="title column span-6">+/environment/title+</div>
		<div class="menu column span-18 right last">+/environment/menu+</div>
	</div>
	<div class="contents column span-24 last">
		<div class="navigation column span-6">+children+</div>
		<div class="contents column span-18 last">+contents+</div>
	</div>
	<div class="footer column span-24 last">
		<div class="sitemap column span-20">
			+justlogincommand+
			<div class="commands">+commands+</div>
			<div class="views">+views+</div>
			<div class="sitemap">+sitemap+</div>
		</div>
		<div class="column span-4 right last">
			Powered by *Pier>http://www.lukas-renggli.ch/smalltalk/pier*.
		</div>
	</div>
</div>
+googleanalytics+
';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:27'!
googleAnalyticsWidget
	^ googleAnalyticsWidget ifNil: [ 
		googleAnalyticsWidget := (PRComponent named: 'googleanalytics')
		title: 'Google Analytics';
		componentClass: PRGoogleAnalyticsWidget
	]! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 9/6/2008 18:46'!
kernel
	^ kernel ifNil: [
		kernel := PRKernel named: 'pier'.
		kernel root: self root.
		kernel
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:28'!
loginCommandWidget
	^ loginCommandWidget ifNil: [
		loginCommandWidget := (PRComponent named: 'justlogincommand')
		title: 'Just Login Command';
		componentClass: PRCommandsWidget;
		settingsAt:  PRCommandsWidget descriptionCommandClasses put: (Array with: PULogin);
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:28'!
mainEnvironmentPage
	^ mainEnvironmentPage ifNil: [
	mainEnvironmentPage := (PRPage named: 'mainenvironment')
		title: '_Main Environment';
		contents: 
'<div class="container">
	<div class="header column span-24 last">
		<div class="title column span-6">+/environment/title+</div>
		<div class="menu column span-18 right last">+/environment/menu+</div>
	</div>
	<div class="contents column span-24 last">
		<div class="contents column span-12">+/environment/contents+</div>
		<div class="contents column prepend-6 span-6 last">+/environment/postticker+</div>
	</div>
	<div class="footer column span-24 last">
		<div class="sitemap column span-20">
			+/environment/justlogincommand+
			<div class="commands">+/environment/commands+</div>
			<div class="views">+/environment/views+</div>
			<div class="sitemap">+/environment/sitemap+</div>
		</div>
		<div class="column span-4 right last">
			Powered by *Pier>http://www.lukas-renggli.ch/smalltalk/pier*.
		</div>
	</div>
</div>
+/environment/googleanalytics+
';
		yourself
	]! !

!PRDistribution methodsFor: 'rights' stamp: 'tg 9/5/2008 22:52'!
makePrivate: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRDistribution methodsFor: 'rights' stamp: 'tg 9/5/2008 22:59'!
makePublic: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:29'!
menuWidget
	^ menuWidget ifNil: [
		menuWidget := (PRComponent named: 'menu')
		componentClass: PRChildrenWidget;
		write: 1
			using: PRChildrenWidget descriptionLevel;
		write: true
			using: PRChildrenWidget descriptionHighlightPath;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:29'!
metaEnvironmentPage
	^ metaEnvironmentPage ifNil: [
		metaEnvironmentPage := (PRPage named: 'metaenvironment')
		title: '_Meta Environment';
		hideFromMenus: true;
		contents: '<div class="container metaenvironment">
	<div class="span-24 last metaheader">
		Meta page: +/environment/breadcrumb+
	</div>
	<div class="span-24 last">
		+/environment/contents+
	</div>
	<div class="span-24 last metafooter">
		<div class="span-10">+/environment/commands+</div>
		<div class="span-10 last">+/environment/sitemap+</div>
	</div>

</div>';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:30'!
postTickerWidget
	^ postTickerWidget ifNil: [
		postTickerWidget := (PRComponent named: 'postticker')
		title: 'Post Ticker';
		componentClass: PBPostTicker;
		write: blog using: PBPostTicker descriptionBlog;
		yourself
	]! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 9/6/2008 18:46'!
register 
	PRPierFrame 
		registerAsApplication: 'pier'
		kernel: self kernel! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 9/6/2008 18:42'!
root
	self rootPage
		addChild: self blog;
		addChild: (self environmentPage
				addChild: self siteTitlePage;
				addChild: self menuWidget;
				addChild: self childrenWidget;
				addChild: self breadcrumbWidget;
				addChild: self googleAnalyticsWidget;
				addChild: self sitemapPage;
				addChild: self viewsPage;
				addChild: self commandsPage;
				addChild: self loginCommandWidget;
				addChild: self contentsWidget;
				addChild: self stylesheetFile;
				addChild: self systemManagementPage;
				addChild: self postTickerWidget;
				yourself);
		addChild: self mainEnvironmentPage;
		addChild: self metaEnvironmentPage.
	self rootPage localEnvironment: self mainEnvironmentPage.
	self blog localEnvironment: self environmentPage.
	self environmentPage localEnvironment: self metaEnvironmentPage.
	self mainEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self metaEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self rootPage localStyleSheet: self stylesheetFile.
	self rootPage enumerator
		with;
		all;
		do: 
			[ :each | 
			each securityDecoration owner: self kernel users anyOne.
			each securityDecoration group: self kernel groups anyOne ].
	self makePrivate: self environmentPage.
	self makePrivate: self mainEnvironmentPage.
	self makePrivate: self metaEnvironmentPage.
	self makePrivate: self sitemapPage.
	self makePrivate: self viewsPage.
	self makePrivate: self commandsPage.
	self makePrivate: self systemManagementPage.
	^self rootPage! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:43'!
rootPage
	^ rootPage ifNil: [
		rootPage := (PRPage named: 'pier')
					contents: 'Welcome to Pier!!'
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:31'!
siteTitlePage
	^ siteTitlePage ifNil: [
		siteTitlePage := (PRPage named: 'title')
		contents: '!!*/*';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:32'!
sitemapPage
	^ sitemapPage ifNil: [
		sitemapPage := (PRPage named: 'sitemap')
			addChild: ((PRComponent named: 'widget')
				componentClass: PRTreeWidget;
				yourself);
			contents:
'Sitemap
+widget+'
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:44'!
stylesheetFile
	^ stylesheetFile ifNil: [stylesheetFile := (PRFile named: 'css')
		mimetype: 'text/css';
		contents: 
'
body {margin-top: 0px;}

h1, h2, h3, h4, h5, h6 { margin: 0; font-weight: inherit; font-size: 100%; line-height: auto; }
h1 { font-size: 2em; margin-bottom: 0.75em; }
h2 { font-size: 1.5em; line-height: 1; margin-bottom: 1em; }
h3 { font-size: 1.2em; height: 1.25em; line-height: 1.25; margin-bottom: 1.25em; }
h4 { font-size: 1em; font-weight: bold; margin-bottom: 1.5em; }
h5 { font-size: 1em; font-weight: bold; }
h6 { font-size: 1em; }


/* PIER */
.broken { color: #8a1f11; }
.protected { color: #514721; }
a.view, a.command {color: gray;}
a {text-decoration: none;}
a.environment:after {content: "*";}
.right {text-align: right;}
.center {text-align: center;}
.float {float: right;}

/* HEADER */
.header .title a.page {
	outline: none;
	display: block;
}
.header .search input {
	width: 220px;
	outline: none;
}
.header .search ul {
	margin: 0;
	padding: 0;
	background: #fff;
	list-style-type: none;
	border: 1px solid #666;
	border-top: none;}
.header .search li.selected {
	background-color: #009;}
.header .search li {
	margin: 0;
	display: block;
	padding: 0.2em;
	cursor: pointer;
	list-style-type: none;}
.header .search a {
	text-decoration: none;}
.header .search li.selected a {
	color: #fff;}
.header .menu {
	height: 4em;}
.header .menu ul {
	margin: 0 0 1em 0;
	list-style-type: none;}
.header .menu ul li {
	display: inline;
	margin-right: 10px;
	list-style-type: none;}
.header .menu .active {
	font-weight: bold;}

/* NAVIGATION */
.navigation ul {
	margin-top: 0;
	margin-left: 0;
	list-style-type: none;}
.navigation ul ul {
	margin-bottom: 0;
	margin-left: 1.5em;}
.navigation .active {
	font-weight: bold;}

.contents {margin-bottom: 5em;}

/* FOOTER */
.footer {
	font-size: 80%;
	text-align: left;
	border-top: 1px solid #ddd;}
.footer ul {list-style: none; margin-left: 0em;}
.footer ul ul {margin-left: 1.5em;}
.footer .commands ul, .footer .views ul {display: inline;}
.footer .commands ul li, .footer .views ul li {display: inline; padding-right: 1em;}

/* META */
.metaheader {background: #C3D9FF; font-size: 200%}
.metaheader ul {display: inline; margin: 0;}
.metaheader li {list-style: none; display: inline; margin: 0;}
.metaheader li:after {content: "/"}
.metaenvironment.container {border: 1px solid #C3D9FF; margin-top: 0;}
.metafooter {background: #C3D9FF;}
.metafooter li {list-style: none;}
'
]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:33'!
systemManagementPage
	^ systemManagementPage ifNil: [
		systemManagementPage := (PRPage named: 'systemmanagement')
		title: '_System Management';
		addChild: ((PRComponent named: 'users')
				componentClass: PUUsersWidget;
				yourself);
		addChild: ((PRComponent named: 'groups')
				componentClass: PUGroupsWidget;
				yourself);
		addChild: ((PRComponent named: 'persistency')
				componentClass: PRPersistencySettings;
				yourself);
		addChild: ((PRComponent named: 'kernel')
				componentClass: PRKernelSettings;
				yourself);
		contents: '!!Users
+users+

!!User Group
+groups+

!!Persistency
+persistency+

!!Pier Kernel Settings
+kernel+

';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:33'!
viewsPage
	^ viewsPage ifNil: [
		viewsPage := (PRPage named: 'views')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRViewsWidget;
				yourself);
		contents: 'Views: +widget+'
	]! !
